> For the complete documentation index, see [llms.txt](https://apidocs.akinon.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://apidocs.akinon.com/commerce-openapis/basket/introduction/unavailable-product-scenarios.md).

# Unavailable Product Scenarios

The system automatically handles products that become unavailable after being added to the basket:

**Automatic Removal:**

* On basket retrieval (GET /basket/), unavailable products are automatically removed
* Removed products are listed in `unavailable_basket_products` response field
* Includes product details and quantity that was removed

**Unavailability Reasons:**

* Product becomes inactive (`is_active = false`)
* Product type changes to non-purchasable (product\_meta, grouped)
* Insufficient stock for requested quantity
* Product deleted from system
* Marketplace: Datasource becomes inactive or product mapping removed

**Response Handling:**

* `unavailable_basket_products` array contains removed items
* Each entry includes: `pk`, `name`, `unavailable_quantity`
* Promotional offers are recalculated without removed items
* Client should display notification about removed products


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://apidocs.akinon.com/commerce-openapis/basket/introduction/unavailable-product-scenarios.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
